﻿using System;
using Telerik.Windows.DragDrop.Behaviors;
using Telerik.Windows.Controls.ScheduleView;

namespace SilverlightApplication2
{
	public class DataConverterAppointments : DataConverter
	{
		/// <summary>
		/// Retrieves a data object in a specified format; the data format is specified by a string.
		/// </summary>
		public override object ConvertTo(object data, string format)
		{
			if (DataObjectHelper.GetDataPresent(data, ScheduleViewDragDropPayload.PayloadFormat, false))
			{
				var payload = DataObjectHelper.GetData(data, ScheduleViewDragDropPayload.PayloadFormat, false) as ScheduleViewDragDropPayload;

				return payload.DraggedAppointments;
			}
			return null;
		}

		/// <summary>
		/// Returns a list of all formats that the data in this data object can be converted to.
		/// </summary>
		public override string[] GetConvertToFormats()
		{
			return new string[] { typeof(Appointment).AssemblyQualifiedName };
		}
	}
}