﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Media;
using SWC = System.Windows.Controls;

namespace Telerik.Windows.Controls.TreeView
{
	internal static class TreeViewHelper
	{
		public static SWC.ItemsControl GetParent(this RadTreeViewItem item)
		{
			return (SWC.ItemsControl)item.ParentItem ?? item.ParentTreeView;
		}

		public static IEnumerable<object> GetSelectedItems(this RadTreeView treeView, Type itemType)
		{
			if (treeView == null)
			{
				return Enumerable.Empty<object>();
			}

			return  treeView.Normalize(treeView.SelectedItems);
		}

		private static IEnumerable<object> Normalize(this RadTreeView treeView, IEnumerable<object> items)
		{
			return items.Where(item =>
			{
				var container = treeView.ContainerFromItemRecursive(item);
				if (container != null)
				{
					var ancestorItems = GetAncestors(container).OfType<RadTreeViewItem>().Select(ancestor => ancestor.Item);

					var result = !ancestorItems.Any(treeView.SelectedItems.Contains);

					return result;
				}
				return true;
			}).ToList();
		}

		private static IEnumerable<RadTreeViewItem> GetAncestors(RadTreeViewItem item)
		{
			while (item != null)
			{
				item = item.ParentItem;
				yield return item;
			}

			yield break;
		}
	}
}