﻿using System.Collections.ObjectModel;
using Telerik.Windows.Controls.ScheduleView;
using System;

namespace SilverlightApplication2
{
	public class ViewModel
	{
		public ViewModel()
		{
			var today = DateTime.Today;

			this.Appointments1 = new ObservableCollection<Appointment>
			{
				new Appointment { Subject="Appointment 1", Start = today.AddHours(2), End = today.AddHours(3) },
				new Appointment { Subject="Appointment 2", Start = today.AddHours(3), End = today.AddHours(4) },
				new Appointment { Subject="Appointment 3", Start = today.AddHours(4), End = today.AddHours(5) }
			};

			this.Appointments2 = new ObservableCollection<Appointment>
			{
				new Appointment { Subject="Appointment 4", Start = today.AddHours(3), End = today.AddHours(4) }
			};

			this.Appointments3 = new ObservableCollection<Appointment>
			{
				new Appointment { Subject="Custom Appointment 5", Start = today.AddHours(5), End = today.AddHours(6) }
			};

			this.Appointments4 = new ObservableCollection<AppointmentGroup>
			{
				new AppointmentGroup { Title = "Room 1", Appointments = new ObservableCollection<Appointment>
					{ 
						new Appointment { Subject="Appointment 6", Start = today.AddHours(5), End = today.AddHours(6) },
						new Appointment { Subject="Appointment 7", Start = today.AddHours(5), End = today.AddHours(6) }
					} },
				new AppointmentGroup { Title = "Room 2", Appointments = new ObservableCollection<Appointment>
					{
						new Appointment { Subject="Appointment 8", Start = today.AddHours(5), End = today.AddHours(6) },
						new Appointment { Subject="Appointment 9", Start = today.AddHours(5), End = today.AddHours(6) }					
					} },
				new AppointmentGroup { Title = "Room 3", Appointments = new ObservableCollection<Appointment>
					{ 
						new Appointment { Subject="Appointment 10", Start = today.AddHours(5), End = today.AddHours(6) },
						new Appointment { Subject="Appointment 11", Start = today.AddHours(5), End = today.AddHours(6) }
					} }
			};
		}

		public ObservableCollection<Appointment> Appointments1 { get; private set; }
		public ObservableCollection<Appointment> Appointments2 { get; private set; }
		public ObservableCollection<Appointment> Appointments3 { get; private set; }
		public ObservableCollection<AppointmentGroup> Appointments4 { get; private set; }
	}

	public class AppointmentGroup
	{
		public string Title { get; set; }
		public ObservableCollection<Appointment> Appointments { get; set; }

		public override string ToString()
		{
			return string.Format("{0} Count:{1}", this.Title, this.Appointments.Count);
		}
	}
}